#!/usr/bin/python
# extract session and salt from Oracle trace files
# (c) Nov 2012 v0.1, Alex Stanev <alex@stanev.org>
# http://sec.stanev.org
# The source code is distributed under GPLv3 license
import os
import sys
import re

jtr = False
tfile = ''
if len(sys.argv) == 2:
    tfile = sys.argv[1]

if len(sys.argv) == 3:
    jtr = sys.argv[1] == '-jtr'
    tfile = sys.argv[2]

if tfile == '':
    print 'Extract o5logon session and salt from Oracle trace files'
    print '(c) Nov 2012 v0.1, Alex Stanev <alex@stanev.org>'
    print 'Default output is in hashkill format.\nUse -jtr for John the Ripper'
    print sys.argv[0]+' [-jtr] trace_file'
    exit(0)

if (not os.path.isfile(tfile)):
    print 'trace file %s does not exists' % tfile
    exit(1)

pl = ''
with open(tfile, 'r') as tf:
    for l in tf:
        p = l.split('|');
        if len(p) == 3:
            pl += p[1]

striplc = re.compile(u'[^a-z\s]+')
striph = re.compile(u'[^0-9A-F\s]+')
# try to find user
while True:
    pos = pl.find('AUTH_TERMINAL')
    if (pos == -1):
        #print 'could not extract DB user'
        break
    username = striplc.sub('', pl[pos-10:pos])

    # try to find session
    pos = pl.find('AUTH_SESSKEY')
    if (pos == -1):
        #print 'could not extract AUTH_SESSKEY'
        break
    sess = striph.sub('', pl[pos+12:pos+111])

    # try to find salt
    pos = pl.find('AUTH_VFR_DATA')
    if (pos == -1):
        #print 'could not extract AUTH_VFR_DATA'
        break
    salt = striph.sub('', pl[pos+13:pos+40])

    # remove parsed part
    pl = pl[pos+40:]

    if jtr:
        print 'o5logon$%s*%s' % (sess, salt)
    else:
        print '%s:%s:%s' % (username, sess, salt)
